; Released under no particular license by Jonathan G. Rennison j.g.rennison@gmail.com
; 29/9/2008

%include "macros.inc"

SECTION CODE USE32 CLASS=CODE
..start:
	Kcall GetModuleFileNameW, 0, modulefilename, 245
	mov [modulefilenamelen], eax

	call rereadconfig

	push edi
	mov edi, [modulefilenameprt]
	mov DWORD [edi], 0

	dec edi
	dec edi
	mov ecx, [modulefilenamelen]
	mov eax, '\'
	std
	repne scasw
	add edi, 4
	cld

	Kcall GetModuleHandleA, 0
	mov [pid], eax
	
	;mov DWORD [wndclass+WNDCLASSEX.cbSize], WNDCLASSEX_size
	;mov DWORD [wndclass+WNDCLASS.style], 0
	mov DWORD [wndclass+WNDCLASS.lpszClassName], edi
	mov DWORD [wndclass+WNDCLASS.lpfnWndProc], wndproc
	mov DWORD [wndclass+WNDCLASS.hInstance], eax

	pop edi

	Ucall RegisterClassW, wndclass
	or eax, eax
	jz .ret

	Ucall CreateWindowExW, 0, [wndclass+WNDCLASS.lpszClassName], wintitle, WS_POPUP, 0, 0, 0, 0, 0, 0, [pid], 0
	or eax, eax
	jnz .beginmessageloop
	.ret:
	ret

.loop:
	Ucall TranslateMessage, msg
	Ucall DispatchMessageW, msg
.beginmessageloop:
	Ucall GetMessageW, msg, 0, 0, 0
	or eax, eax
	jnz .loop
	mov eax, [msg+MSG.wParam]
	ret

rereadconfig:
	mov eax, [modulefilenamelen]
	add eax, eax
	add eax, modulefilename
	mov DWORD [eax], "." + ("h"<<16)
	mov DWORD [eax+4], "w" + ("n"<<16)
	mov DWORD [eax+8], "d"
	mov [modulefilenameprt], eax

	Kcall CreateFileW, modulefilename, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0
	or eax, eax
	jz .fexit
	
	push eax

	Kcall ReadFile, eax, hwnd, 8, msg, 0
	
	xchg eax, [esp]
	Kcall CloseHandle, eax

	pop eax

	or eax, eax
	jz .fexit
	cmp DWORD [msg], 8
	jne .fexit

	or eax, BYTE -1
	ret
.fexit:
	xor eax, eax
	ret

wndproc:
	mov eax, [MSGmsg]
	cmp eax, WM_DESTROY
	je .quit
	cmp eax, WM_USER+36
	je .quit
	cmp eax, WM_USER+30
	jb .norm
	cmp eax, WM_USER+38
	ja .norm

	push eax
	call rereadconfig
	pop ecx
	or eax, eax
	jz .norm

	add ecx, [msgoffset]
	Ucall PostMessageW, [hwnd], ecx, [MSGwPrm+4], [MSGlPrm]
	xor eax, eax
	ret 16

.norm:
	ei DefWindowProcW, user32.dll
	jmp [DefWindowProcW]

.quit:
	Ucall PostQuitMessage, 0
	xor eax, eax
	ret 16
	
wintitle db "window1", 0

SECTION BSS USE32 CLASS=BSS
pid resd 1
wndclass resd WNDCLASS_size/4
modulefilename resd 64
modulefilenamelen resd 1
modulefilenameprt resd 1
msg resd 7

hwnd resd 1
msgoffset resd 1